diff -Nurd unrar-orig/cmddata.cpp unrar/cmddata.cpp
--- unrar-orig/cmddata.cpp	2007-09-04 14:56:54 +0200
+++ unrar/cmddata.cpp	2007-09-07 20:50:36 +0200
@@ -957,7 +957,7 @@
 #endif
 #ifndef _WIN_32
     static MSGID Win32Only[]={
-      MCHelpSwIEML,MCHelpSwVD,MCHelpSwAC,MCHelpSwAO,MCHelpSwOS,MCHelpSwIOFF,
+      MCHelpSwIEML,MCHelpSwVD,MCHelpSwAO,MCHelpSwOS,MCHelpSwIOFF,
       MCHelpSwEP2,MCHelpSwOC
     };
     bool Found=false;
@@ -997,6 +997,10 @@
 #endif
     }
 #endif
+#if !defined(_WIN_32) && !defined(_EMX)
+    if (Help[I]==MCHelpSwAC)
+      continue;
+#endif
 #endif
     mprintf(St(Help[I]));
   }
diff -Nurd unrar-orig/filefn.cpp unrar/filefn.cpp
--- unrar-orig/filefn.cpp	2007-09-04 14:56:54 +0200
+++ unrar/filefn.cpp	2007-09-07 20:29:04 +0200
@@ -189,6 +189,7 @@
       return(int32to64(uiUserFree.u.HighPart,uiUserFree.u.LowPart));
   }
 
+#ifndef _DJGPP
   DWORD SectorsPerCluster,BytesPerSector,FreeClusters,TotalClusters;
   if (!GetDiskFreeSpace(*Root ? Root:NULL,&SectorsPerCluster,&BytesPerSector,&FreeClusters,&TotalClusters))
     return(1457664);
@@ -221,12 +222,17 @@
     return(FreeSize);
   }
   else
+#endif
   {
     union REGS regs,outregs;
     memset(&regs,0,sizeof(regs));
     regs.h.ah=0x36;
     regs.h.dl=Drive;
+#ifdef _DJGPP
+    int86 (0x21,&regs,&outregs);
+#else
     _int86 (0x21,&regs,&outregs);
+#endif
     if (outregs.x.ax==0xffff)
       return(1457664);
     Int64 FreeSize=outregs.x.ax*outregs.x.cx;
diff -Nurd unrar-orig/find.cpp unrar/find.cpp
--- unrar-orig/find.cpp	2007-09-04 14:56:54 +0200
+++ unrar/find.cpp	2007-09-07 20:29:04 +0200
@@ -161,9 +161,7 @@
       fd->Error=(errno!=ENOENT);
       return(false);
     }
-#ifdef _DJGPP
-  fd->FileAttr=chmod(FindMask,0);
-#elif defined(_EMX)
+#if defined(_EMX) && !defined(_DJGPP)
   fd->FileAttr=st.st_attr;
 #else
   fd->FileAttr=st.st_mode;
diff -Nurd unrar-orig/makefile.dj unrar/makefile.dj
--- unrar-orig/makefile.dj	1970-01-01 01:00:00 +0100
+++ unrar/makefile.dj	2007-09-07 21:14:46 +0200
@@ -0,0 +1,50 @@
+#
+# Makefile for DJGPP - unrar
+#
+# Note: you have to 'make clean' before you can build
+#	the sfx module
+#
+
+# DOS32 using DJGPP 2.03 Patchlevel 2 and GCC 2.95.3
+CXX = gpp
+CXXFLAGS = -O2 -Wno-deprecated
+#DEFINES = -D_MSC_VER -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
+
+##########################
+
+.PHONY: all clean veryclean
+
+COMPILE=$(CXX) $(CXXFLAGS) $(DEFINES)
+LINK=$(CXX)
+
+UNRAR_OBJ=filestr.o recvol.o rs.o scantree.o
+
+OBJECTS=rar.o strlist.o strfn.o pathfn.o int64.o savepos.o global.o \
+	file.o filefn.o filcreat.o archive.o arcread.o unicode.o \
+	system.o isnt.o crypt.o crc.o rawread.o encname.o \
+	resource.o match.o timefn.o rdwrfn.o consio.o options.o \
+	ulinks.o errhnd.o rarvm.o rijndael.o getbits.o sha1.o \
+	extinfo.o extract.o volume.o list.o find.o unpack.o cmddata.o
+
+.cpp.o:
+	$(COMPILE) -D$(WHAT) -c $<
+
+all:	unrar
+
+unrar:	WHAT=UNRAR
+unrar:	$(OBJECTS) $(UNRAR_OBJ)
+	$(LINK) -Wl,-s -o unrar.exe $(LDFLAGS) $(OBJECTS) $(UNRAR_OBJ) $(LIBS)
+	exe2coff unrar.exe
+	cp -u $(DJDIR)/bin/cwsdstub.exe .
+	copy /b cwsdstub.exe+unrar unrar.exe
+	-upx --ultra-brute unrar.exe
+
+sfx:	WHAT=SFX_MODULE
+sfx:	$(OBJECTS)
+	$(LINK) -Wl,-s -o default.sfx $(LDFLAGS) $(OBJECTS) -DSFX_MODULE
+
+clean:
+	$(RM) $(OBJECTS) $(UNRAR_OBJ)
+
+veryclean: clean
+	$(RM) unrar.exe default.sfx cwsdstub.exe unrar
diff -Nurd unrar-orig/pathfn.cpp unrar/pathfn.cpp
--- unrar-orig/pathfn.cpp	2007-09-04 14:56:54 +0200
+++ unrar/pathfn.cpp	2007-09-07 20:29:04 +0200
@@ -334,6 +334,7 @@
     strcpy(RARFileName,Path);
   if (Number!=0)
     return(false);
+#ifndef _DJGPP
   if (_osmode==OS2_MODE)
   {
     PTIB ptib;
@@ -342,6 +343,7 @@
     DosQueryModuleName(ppib->pib_hmte,NM,Path);
   }
   else
+#endif
     strcpy(Path,RARFileName);
   RemoveNameFromPath(Path);
   return(true);
